'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _d3Color = require('d3-color');

var _d3Ease = require('d3-ease');

var ease = _interopRequireWildcard(_d3Ease);

var _d3Interpolate = require('d3-interpolate');

var _d3Scale = require('d3-scale');

var _d3Selection = require('d3-selection');

var _d3Shape = require('d3-shape');

var _d3Timer = require('d3-timer');

require('d3-transition');

var _Gradient = require('./Gradient');

var _Gradient2 = _interopRequireDefault(_Gradient);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * PropType for fill and stroke..
 */
var fillStroke = _react.PropTypes.shape({
    fill: _react.PropTypes.string,
    stroke: _react.PropTypes.string
});

var ucfirst = function ucfirst(s) {
    return s && s[0].toUpperCase() + s.slice(1);
};

var LiquidFillGauge = (_temp = _class = function (_Component) {
    _inherits(LiquidFillGauge, _Component);

    function LiquidFillGauge() {
        _classCallCheck(this, LiquidFillGauge);

        return _possibleConstructorReturn(this, (LiquidFillGauge.__proto__ || Object.getPrototypeOf(LiquidFillGauge)).apply(this, arguments));
    }

    _createClass(LiquidFillGauge, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.draw();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            this.draw();
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
        }
    }, {
        key: 'draw',
        value: function draw() {
            var _this2 = this;

            var data = [];
            var samplePoints = 40;
            for (var i = 0; i <= samplePoints * this.props.waveFrequency; ++i) {
                data.push({
                    x: i / (samplePoints * this.props.waveFrequency),
                    y: i / samplePoints
                });
            }

            this.wave = (0, _d3Selection.select)(this.clipPath).datum(data).attr('T', '0');

            var textElement = (0, _d3Selection.select)(this.container).selectAll('text').selectAll('tspan.value');

            var waveHeightScale = (0, _d3Scale.scaleLinear)().range([0, this.props.waveAmplitude, 0]).domain([0, 50, 100]);

            var fillWidth = this.props.width * (this.props.innerRadius - this.props.margin);
            var waveScaleX = (0, _d3Scale.scaleLinear)().range([-fillWidth, fillWidth]).domain([0, 1]);

            var fillHeight = this.props.height * (this.props.innerRadius - this.props.margin);
            var waveScaleY = (0, _d3Scale.scaleLinear)().range([fillHeight / 2, -fillHeight / 2]).domain([0, 100]);

            if (this.props.waveAnimation) {
                this.animateWave();
            }

            if (this.props.riseAnimation) {
                (function () {
                    var clipArea = (0, _d3Shape.area)().x(function (d, i) {
                        return waveScaleX(d.x);
                    }).y1(function (d) {
                        return _this2.props.height / 2;
                    });
                    var timeScale = (0, _d3Scale.scaleLinear)().range([0, 1]).domain([0, _this2.props.riseAnimationTime]);
                    // Use the old value if available
                    var interpolate = (0, _d3Interpolate.interpolateNumber)(_this2.wave.node().oldValue || 0, _this2.props.value);
                    var easing = 'ease' + ucfirst(_this2.props.riseAnimationEasing);
                    var easingFn = ease[easing] ? ease[easing] : ease.easeCubicInOut;
                    var riseAnimationTimer = (0, _d3Timer.timer)(function (t) {
                        var value = interpolate(easingFn(timeScale(t)));
                        clipArea.y0(function (d, i) {
                            var radians = Math.PI * 2 * (d.y * 2); // double width
                            return waveScaleY(waveHeightScale(value) * Math.sin(radians) + value);
                        });
                        textElement.text(Math.round(value));
                        _this2.wave.attr('d', clipArea);

                        _this2.props.riseAnimationOnProgress({
                            value: value,
                            container: (0, _d3Selection.select)(_this2.container)
                        });

                        if (t >= _this2.props.riseAnimationTime) {
                            (function () {
                                riseAnimationTimer.stop();

                                var value = interpolate(1);
                                clipArea.y0(function (d, i) {
                                    var radians = Math.PI * 2 * (d.y * 2); // double width
                                    return waveScaleY(waveHeightScale(value) * Math.sin(radians) + value);
                                });

                                textElement.text(Math.round(value));
                                _this2.wave.attr('d', clipArea);

                                _this2.props.riseAnimationOnComplete({
                                    value: value,
                                    container: (0, _d3Selection.select)(_this2.container)
                                });
                            })();
                        }
                    });

                    // Store the old value that can be used for the next animation
                    _this2.wave.node().oldValue = _this2.props.value;
                })();
            } else {
                (function () {
                    var value = _this2.props.value;
                    var clipArea = (0, _d3Shape.area)().x(function (d, i) {
                        return waveScaleX(d.x);
                    }).y0(function (d, i) {
                        var radians = Math.PI * 2 * (d.y * 2); // double width
                        return waveScaleY(waveHeightScale(value) * Math.sin(radians) + value);
                    }).y1(function (d) {
                        return _this2.props.height / 2;
                    });

                    _this2.wave.attr('d', clipArea);
                    textElement.text(Math.round(_this2.props.value));
                })();
            }
        }
    }, {
        key: 'animateWave',
        value: function animateWave() {
            var _this3 = this;

            var width = this.props.width * (this.props.innerRadius - this.props.margin) / 2;
            var waveAnimationScale = (0, _d3Scale.scaleLinear)().range([-width, width]).domain([0, 1]);
            var easing = 'ease' + ucfirst(this.props.waveAnimationEasing);
            var easingFn = ease[easing] ? ease[easing] : ease.easeLinear;

            this.wave.attr('transform', 'translate(' + waveAnimationScale(this.wave.attr('T')) + ', 0)').transition().duration(this.props.waveAnimationTime * (1 - this.wave.attr('T'))).ease(easingFn).attr('transform', 'translate(' + waveAnimationScale(1) + ', 0)').attr('T', '1').on('end', function () {
                _this3.wave.attr('T', '0');
                if (_this3.props.waveAnimation) {
                    _this3.animateWave();
                }
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var style = this.props.style;

            var radius = Math.min(this.props.height / 2, this.props.width / 2);
            var fillCircleRadius = radius * (this.props.innerRadius - this.props.margin);
            var circle = (0, _d3Shape.arc)().outerRadius(this.props.outerRadius * radius).innerRadius(this.props.innerRadius * radius).startAngle(0).endAngle(Math.PI * 2);
            var cX = this.props.width / 2;
            var cY = this.props.height / 2;
            var textPixels = this.props.textSize * radius / 2;
            var fillColor = this.props.waveStyle.fill;
            var gradientStops = this.props.gradientStops || [{
                key: '0%',
                stopColor: (0, _d3Color.color)(fillColor).darker(0.5).toString(),
                stopOpacity: 1,
                offset: '0%'
            }, {
                key: '50%',
                stopColor: fillColor,
                stopOpacity: 0.75,
                offset: '50%'
            }, {
                key: '100%',
                stopColor: (0, _d3Color.color)(fillColor).brighter(0.5).toString(),
                stopOpacity: 0.5,
                offset: '100%'
            }];

            return _react2.default.createElement(
                'div',
                {
                    style: _extends({
                        width: this.props.width,
                        height: this.props.height
                    }, style)
                },
                _react2.default.createElement(
                    'svg',
                    { width: '100%', height: '100%' },
                    _react2.default.createElement(
                        'g',
                        {
                            ref: function ref(c) {
                                _this4.container = c;
                            },
                            transform: 'translate(' + cX + ',' + cY + ')'
                        },
                        _react2.default.createElement(
                            'defs',
                            null,
                            _react2.default.createElement(
                                'clipPath',
                                { id: 'clip' },
                                _react2.default.createElement('path', {
                                    ref: function ref(c) {
                                        _this4.clipPath = c;
                                    }
                                })
                            )
                        ),
                        _react2.default.createElement(
                            'text',
                            {
                                className: 'text',
                                style: {
                                    textAnchor: 'middle',
                                    fontSize: textPixels + 'px'
                                },
                                fill: this.props.textStyle.fill,
                                stroke: this.props.textStyle.stroke,
                                transform: 'translate(' + this.props.textOffsetX + ',' + this.props.textOffsetY + ')'
                            },
                            _react2.default.createElement(
                                'tspan',
                                { className: 'value' },
                                this.props.value
                            ),
                            _react2.default.createElement(
                                'tspan',
                                null,
                                this.props.percentageSymbol
                            )
                        ),
                        _react2.default.createElement(
                            'g',
                            { clipPath: 'url(#clip)' },
                            _react2.default.createElement('circle', {
                                className: 'wave',
                                r: fillCircleRadius,
                                fill: this.props.gradient ? 'url(#gradient)' : this.props.waveStyle.fill
                            }),
                            _react2.default.createElement(
                                'text',
                                {
                                    className: 'waveText',
                                    style: {
                                        textAnchor: 'middle',
                                        fontSize: textPixels + 'px'
                                    },
                                    fill: this.props.waveTextStyle.fill,
                                    stroke: this.props.waveTextStyle.stroke,
                                    transform: 'translate(' + this.props.textOffsetX + ',' + this.props.textOffsetY + ')'
                                },
                                _react2.default.createElement(
                                    'tspan',
                                    { className: 'value' },
                                    this.props.value
                                ),
                                _react2.default.createElement(
                                    'tspan',
                                    null,
                                    this.props.percentageSymbol
                                )
                            )
                        ),
                        _react2.default.createElement('path', {
                            className: 'circle',
                            d: circle(),
                            fill: this.props.circleStyle.fill,
                            stroke: this.props.circleStyle.stroke
                        }),
                        _react2.default.createElement('circle', {
                            r: radius,
                            fill: 'rgba(0, 0, 0, 0)',
                            stroke: 'rgba(0, 0, 0, 0)',
                            style: { pointerEvents: 'all' },
                            onClick: function onClick() {
                                _this4.props.onClick();
                            }
                        })
                    ),
                    _react2.default.createElement(
                        _Gradient2.default,
                        { id: 'gradient' },
                        gradientStops.map(function (stop, index) {
                            if (!_react2.default.isValidElement(stop)) {
                                var key = stop.key || index;
                                return _react2.default.createElement('stop', _extends({ key: key }, stop));
                            }
                            return stop;
                        })
                    )
                )
            );
        }
    }]);

    return LiquidFillGauge;
}(_react.Component), _class.propTypes = {
    // The width of the component.
    width: _react.PropTypes.number,
    // The height of the component.
    height: _react.PropTypes.number,

    // The percentage value (0-100).
    value: _react.PropTypes.number,
    // The percentage symbol (%).
    percentageSymbol: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),

    // The relative height of the text to display in the wave circle. 1 = 50%.
    textSize: _react.PropTypes.number,
    textOffsetX: _react.PropTypes.number,
    textOffsetY: _react.PropTypes.number,

    // Controls if the wave should rise from 0 to it's full height, or start at it's full height.
    riseAnimation: _react.PropTypes.bool,
    // The amount of time in milliseconds for the wave to rise from 0 to it's final height.
    riseAnimationTime: _react.PropTypes.number,
    // [d3-ease](https://github.com/d3/d3-ease) options:
    // See the [easing explorer](http://bl.ocks.org/mbostock/248bac3b8e354a9103c4) for a visual demostration.
    riseAnimationEasing: _react.PropTypes.string,
    // Progress callback function.
    riseAnimationOnProgress: _react.PropTypes.func,
    // Complete callback function.
    riseAnimationOnComplete: _react.PropTypes.func,

    // Controls if the wave scrolls or is static.
    waveAnimation: _react.PropTypes.bool,
    // The amount of time in milliseconds for a full wave to enter the wave circle.
    waveAnimationTime: _react.PropTypes.number,
    // [d3-ease](https://github.com/d3/d3-ease) options:
    // See the [easing explorer](http://bl.ocks.org/mbostock/248bac3b8e354a9103c4) for a visual demostration.
    waveAnimationEasing: _react.PropTypes.string,

    // The wave amplitude.
    waveAmplitude: _react.PropTypes.number,
    // The number of full waves per width of the wave circle.
    waveFrequency: _react.PropTypes.number,

    // Whether to apply linear gradients to fill the wave circle.
    gradient: _react.PropTypes.bool,
    // An array of the <stop> SVG element defines the ramp of colors to use on a gradient, which is a child element to either the <linearGradient> or the <radialGradient> element.
    gradientStops: _react.PropTypes.oneOfType([_react.PropTypes.arrayOf(_react.PropTypes.object), _react.PropTypes.arrayOf(_react.PropTypes.node), _react.PropTypes.node]),

    // onClick event handler.
    onClick: _react.PropTypes.func,

    // The radius of the inner circle.
    innerRadius: _react.PropTypes.number,
    // The radius of the outer circle.
    outerRadius: _react.PropTypes.number,
    // The size of the gap between the outer circle and wave circle as a percentage of the outer circle's radius.
    margin: _react.PropTypes.number,

    // The fill and stroke of the outer circle.
    circleStyle: fillStroke,
    // The fill and stroke of the fill wave.
    waveStyle: fillStroke,
    // The fill and stroke of the value text when the wave does not overlap it.
    textStyle: fillStroke,
    // The fill and stroke of the value text when the wave overlaps it.
    waveTextStyle: fillStroke
}, _class.defaultProps = {
    width: 400,
    height: 400,
    value: 0,
    percentageSymbol: '%',
    textSize: 1,
    textOffsetX: 0,
    textOffsetY: 0,
    riseAnimation: false,
    riseAnimationTime: 2000,
    riseAnimationEasing: 'cubicInOut',
    riseAnimationOnProgress: function riseAnimationOnProgress() {},
    riseAnimationOnComplete: function riseAnimationOnComplete() {},
    waveAnimation: false,
    waveAnimationTime: 2000,
    waveAnimationEasing: 'linear',
    waveAmplitude: 1,
    waveFrequency: 2,
    gradient: false,
    gradientStops: null,
    onClick: function onClick() {},
    innerRadius: 0.9,
    outerRadius: 1.0,
    margin: 0.025,
    circleStyle: {
        fill: 'rgb(23, 139, 202)'
    },
    waveStyle: {
        fill: 'rgb(23, 139, 202)'
    },
    textStyle: {
        fill: 'rgb(0, 0, 0)'
    },
    waveTextStyle: {
        fill: 'rgb(255, 255, 255)'
    }
}, _temp);


module.exports = LiquidFillGauge;